#!/usr/bin/lua
require("lib_eor3d_lua")

os.exit()

-- printf
printf = function(s,...)
           return io.write(s:format(...))
         end -- function

--
-- SCRIPT EXAMPLES START
--
printf("EOR3D CONAMSTER * START * MAIN\n")

-- INVERT vBE for main
for i = 1,96,1
do
	line = eor3d_command("E3D_vBE " .. i)
	tmp = tonumber(line)
	if(tmp == 0) then
		tmp = 1
	else
		tmp = 0
	end
	eor3d_command("E3D_vBE " .. i .. " = " .. tmp)

	line = eor3d_command("E3D_vBE " .. i)
	tmp = tonumber(line)
	printf("E3D_vBE %02d is:%d\n",i,tmp)
end

-- INVERT vBA for main
for i = 1,96,1
do
	line = eor3d_command("E3D_vBA " .. i)
	tmp = tonumber(line)
	if(tmp == 0) then
		tmp = 1
	else
		tmp = 0
	end
	eor3d_command("E3D_vBA " .. i .. " = " .. tmp)

	line = eor3d_command("E3D_vBA " .. i)
	tmp = tonumber(line)
	printf("E3D_vBA %02d is:%d\n",i,tmp)
end

-- Print all vBE for main
for i = 1,96,1
do
	line = eor3d_command("E3D_vBE " .. i)
	tmp = tonumber(line)
	printf("E3D_vBE %02d is:%d\n",i,tmp)
end

-- Print all vBA for main
for i = 1,96,1
do
	line = eor3d_command("E3D_vBA " .. i)
	tmp = tonumber(line)
	printf("E3D_vBA %02d is:%d\n",i,tmp)
end

-- Print all vMWR for main
for i = 1,96,1
do
	line = eor3d_command("E3D_vMWR " .. i)
	tmp = tonumber(line)
	printf("E3D_vMWR %02d is:%.2f\n",i,tmp)
end

-- Print all vMWW for main
for i = 1,96,1
do
	line = eor3d_command("E3D_vMWW " .. i)
	tmp = tonumber(line)
	printf("E3D_vMWW %02d is:%.2f\n",i,tmp)
end

--count up all vMWW for main
for i = 1,96,1
do
	line = eor3d_command("E3D_vMWW " .. i)
	tmp = tonumber(line)
	tmp = tmp + 2.1
	eor3d_command("E3D_vMWW " .. i .. " = " .. tmp)
	line = eor3d_command("E3D_vMWW " .. i)
	tmp = tonumber(line)
	printf("E3D_vMWW %02d is:%.2f\n",i,tmp)
end

--count up all vMWR for main
for i = 1,96,1
do
	line = eor3d_command("E3D_vMWR " .. i)
	tmp = tonumber(line)
	tmp = tmp + 2.1
	eor3d_command("E3D_vMWR " .. i .. " = " .. tmp)
	line = eor3d_command("E3D_vMWR " .. i)
	tmp = tonumber(line)
	printf("E3D_vMWR %02d is:%.2f\n",i,tmp)
end

--
printf("EOR3D CONAMSTER *  END  * MAIN\n")
--
--
printf("EOR3D CONAMSTER * START * SLAVES\n")
--
-- INVERT vBE for slave
for i = 1,96,1
do
	line = eor3d_command("E3D_SLvBE " .. i)
	tmp = tonumber(line)
	if(tmp == 0) then
		tmp = 1
	else
		tmp = 0
	end
	eor3d_command("E3D_SLvBE " .. i .. " = " .. tmp)

	line = eor3d_command("E3D_SLvBE " .. i)
	tmp = tonumber(line)
	printf("E3D_SLvBE %02d is:%d\n",i,tmp)
end

-- Print all vBA for slave
for i = 1,96,1
do
	line = eor3d_command("E3D_SLvBA " .. i)
	tmp = tonumber(line)
	printf("E3D_SLvBA %02d is:%d\n",i,tmp)
end

-- Print all vMWR for slave
for i = 1,96,1
do
	line = eor3d_command("E3D_SLvMWR " .. i)
	tmp = tonumber(line)
	printf("E3D_SLvMWR %02d is:%.2f\n",i,tmp)
end

--count up all vMWW for slave
for i = 1,96,1
do
	line = eor3d_command("E3D_SLvMWW " .. i)
	tmp = tonumber(line)
	tmp = tmp + 1.1
	eor3d_command("E3D_SLvMWW " .. i .. " = " .. tmp)
		line = eor3d_command("E3D_SLvMWW " .. i)
	tmp = tonumber(line)
	printf("E3D_SLvMWW %02d is:%.2f\n",i,tmp)
end

printf("EOR3D CONAMSTER *  END  * SLAVE\n")

-- MAP Main to SLAVE - warning needs a lot of performance to map all variables
for i = 1,96,1
do
	line = eor3d_command("E3D_vBE " .. i)
	tmp = tonumber(line)
	eor3d_command("E3D_SLvBE " .. i .. " = " .. tmp)
	line = eor3d_command("E3D_vBE " .. i)
	tmp = tonumber(line)
	printf("E3D_vBE %02d is:%d\n",i,tmp)
	line = eor3d_command("E3D_SLvBE " .. i)
	tmp = tonumber(line)
	printf("E3D_SLvBE %02d is:%d\n",i,tmp)

	line = eor3d_command("E3D_vBA " .. i)
	tmp = tonumber(line)
	eor3d_command("E3D_SLvBA " .. i .. " = " .. tmp)
	line = eor3d_command("E3D_vBA " .. i)
	tmp = tonumber(line)
	printf("E3D_vBA %02d is:%d\n",i,tmp)
	line = eor3d_command("E3D_SLvBA " .. i)
	tmp = tonumber(line)
	printf("E3D_SLvBA %02d is:%d\n",i,tmp)

	line = eor3d_command("E3D_vMWW " .. i)
	tmp = tonumber(line)
	eor3d_command("E3D_SLvMWW " .. i .. " = " .. tmp)
	line = eor3d_command("E3D_vMWW " .. i)
	tmp = tonumber(line)
	printf("E3D_vMWW %02d is:%d\n",i,tmp)
	line = eor3d_command("E3D_SLvMWW " .. i)
	tmp = tonumber(line)
	printf("E3D_SLvMWW %02d is:%d\n",i,tmp)

	line = eor3d_command("E3D_vMWR " .. i)
	tmp = tonumber(line)
	eor3d_command("E3D_SLvMWR " .. i .. " = " .. tmp)
	line = eor3d_command("E3D_vMWR " .. i)
	tmp = tonumber(line)
	printf("E3D_vMWR %02d is:%d\n",i,tmp)
	line = eor3d_command("E3D_SLvMWR " .. i)
	tmp = tonumber(line)
	printf("E3D_SLvMWR %02d is:%d\n",i,tmp)
end

-- trigger a communication like in csv file NAME INDEX | NAME2 INDEX2 | ...
-- this entries are done first, then polling
-- if this command is always new written here, polling will not finish all variables
-- so find a combination between polling or write this command!
eor3d_command("E3D_lua_modbus = SLvBE 12|SLvBE 14|SLvMWW 16|SLvMWW 28")

os.exit()
